package model;

public class RecursiveMethods {
	public boolean groupSum(int start, int[] nums, int target) {
		  return groupSumHelper(start, nums, 0, target);
	}
	
	// To keep track of some intermediate results (sum so far), we
	// create a recursive helper method.
	private boolean groupSumHelper(int index, int[] nums, int sumSoFar, int target) {
		if(index >= nums.length) { // base case 1: no more numbers to choose, make a decision now.
			return sumSoFar == target; // Q. Why not write: return false?
		}
		else { // index < nums.length
			if(sumSoFar == target) { // base case 2: sum of the group chosen so far hits the target.
				return true;
			}
			else if(sumSoFar > target) { // base case 3
				return false;
			}
			else { // sumSoFar < target // there's some scope of choosing more numbers into the group
				return
					// include a[index]
					groupSumHelper(index + 1, nums, sumSoFar + nums[index], target)
					||
					// exclude a[index]
					groupSumHelper(index + 1, nums, sumSoFar, target);
			}
		}
	}
}
